#uses "fwSystemOverview/fwSystemOverviewDeprecated.ctl"
#uses "fwSystemOverview/fwSystemOverviewReport.ctl"
#uses "fwSystemOverview/fwSystemOverviewFsm.ctl"
#uses "fwInstallation/fwInstallationManager.ctl"

mapping allActiveAlarmDpesToTimestamp;//key ->dpe; value->time;text;value
mapping activeAlarmDpeToTimestamp;//key ->dpe; value->time;text;value
mapping alarmToOccurrances;// key -> dpe ; value -> timeLastNotificationSent;numOfOccurrances;timeOcc1;timeOcc2;...timeNumOfIccurrances
mapping systemNameToApplication;
dyn_string connectedSummaryAlerts; // contains list of the _UnApplication dp's for which we have already done a dpConnect to the _dp_list of the summary alert
int cycleTime = 120;//seconds
int lastCycleTime = 120;
int alarmActivePeriod = 15*60;//notify for alarms active for longer than this time(seconds)
int alarmRenotificationPeriod =8*60*60;//seconds
int alarmOccurrancesLimit = 3; // notify for alarms that have appeared more than these times
int alarmOccurrancesPeriod = 1*60*60;    // for this period(seconds)
int alarmOccurrancesRenotificationPeriod =2*60*60;//seconds  
string configDp = "fwSystemOverviewAlarmNotificationConfig";
string smsConfigDpPrefix = "fwSystemOverviewSmsConfig_";
const string FWSYSOVERVIEW_NOTIFICATION_ACTIVEALARMS_DPE = "fwSystemOverviewActiveAlarms.alarms";
const string FWSYSOVERVIEW_NOTIFICATION_HEARTBEAT_DPE = "fwSysOverviewNotificationsHeartbeat.";
const string FWSYSOVERVIEW_NOTIFICATION_ALARMSOCCURRANCES_DPE = "fwSystemOverviewAlarmsOccurrances.alarms";
const string ICE_PIQUET_EMAIL = "en-dep-ice-piquet@cern.ch";
const string ICE_SUBSCRIPTIONS_FILEPATH = "/home/unicryo/PVSS_projects/MOON/subscriptions/subscriptions.txt";
global dyn_int connectedSystems;
dyn_string failedDpDisconnects; // sometimes the dpDisconnect in _fwSysOverviewNotifications_summaryAlarmStateChangedCB fails so I sue this variable to keep track and don't do a dpConnect next time 
//flag showing if I should check whether _general.._string04 is set to YES
bool shouldCheckAlarmAttribute = true;
int minSleepTime = 3; // the minimum time of delay between two cycles
fwSysOverviewNotifications_start()
{
  //connect to the dp for the config
  dpConnect("_fwSysOverviewNotifications_configChangedCB", configDp + ".cycleTime",
            configDp + ".alarmActivePeriod",
            configDp + ".alarmRenotificationPeriod",
            configDp + ".alarmOccurrancesLimit",
            configDp + ".alarmOccurrancesPeriod",
            configDp + ".alarmOccurrancesRenotificationPeriod");
  //dpconnect to the dp for the connected systems - _fwSysOverviewNotifications_connectedSystemsChangedCB
  dpConnect("_fwSysOverviewNotifications_connectedSystemsChangedCB", "_DistManager.State.SystemNums"); 
  time currentTime;
  while (true)
  {
    currentTime = getCurrentTime();
    mapping applicationToText,applicationToDpes;
    fwSysOverviewNotifications_addLocalActiveAlarmsToBuffer(currentTime);
    fwSysOverviewNotifications_checkBufferForOccurrances(currentTime, applicationToText, applicationToDpes);
    dyn_string soTrees;
//    fwSystemOverviewFsm_getTrees(soTrees);  
    soTrees[1] = "fwSO_LHC_Applications";
    for(int j = 1; j<= dynlen(soTrees); j++)
    {    
      dyn_string summaryText, summaryDpes;
      dyn_int types;
      dyn_string applications = fwCU_getChildren(types, soTrees[j]);
      for(int appCount = 1; appCount <= dynlen(applications); appCount++)
      {
        //get all active alarms for this application from the buffer 
        dyn_dyn_anytype appAlarms = fwSysOverviewNotifications_getApplicationActiveAlarmsFromBuffer(applications[appCount], currentTime);     

        
        // check if there are alarms active for time > alarmActivePeriod
        // check if there are alarms for renotification
        string text;
        dyn_string dpes = fwSysOverviewNotifications_checkAlarmsForNotifications(applications[appCount], appAlarms, currentTime, text);
        
        //get the alarm that has occured more than alarmOccurrancesLimit for the alarmOccurrancesPeriod
        if (mappingHasKey(applicationToText, applications[appCount]))
        {
          text = applicationToText[applications[appCount]] + text;
          string dpesOccStr = applicationToDpes[applications[appCount]];
          dyn_string dpesOcc = strsplit(dpesOccStr, ";");
          dynAppend(dpes, dpesOcc);
        }
        if (text != "")
        {
            // if the notifications for this application are active 
          string  smsConfigDp = smsConfigDpPrefix + strtoupper(applications[appCount]);

          if (dpExists(smsConfigDp))
          {
            bool active, includeInOverview;
            dpGet(smsConfigDp + ".active", active,
                  smsConfigDp + ".includeInOverview", includeInOverview);
            if (active)
            {
              text = "(" +applications[appCount]+ ") " + text;
              DebugN("***INFO: Sending notification now: ", applications[appCount], text, dpes);
              fwSysOverviewNotifications_sendNotification(applications[appCount], text, dpes);
              if(includeInOverview)
              {
                dynAppend(summaryText, text);
                dynAppend(summaryDpes, dpes);
              }
            }
          }
        }
      }
    
      if (dynlen(summaryText) > 0)
      {
        fwSysOverviewNotifications_sendSummary(summaryText, summaryDpes, soTrees[j]);
      }
    }
    fwSysOverviewNotifications_copyAlarms();
    int timePassed = getCurrentTime() - currentTime;
//    //DebugN("lastCycleTime: " + lastCycleTime);
    lastCycleTime = timePassed;
    int sleepTime = (cycleTime - timePassed < minSleepTime)?minSleepTime:cycleTime - timePassed;
//    DebugTN("INFO: NOtifications script sleeping now for: ", sleepTime);
    delay(sleepTime);
  }
}

void fwSysOverviewNotifications_copyAlarms()
{
  dyn_string activeAlarms;
  mapping allActiveAlarmDpesToTimestampTmp = allActiveAlarmDpesToTimestamp;
  mapping alarmToOccurrancesTmp = alarmToOccurrances;
  
  dyn_string keys = mappingKeys(allActiveAlarmDpesToTimestampTmp);
  for (int i=1; i<= dynlen(keys); i++)
  {
    string alarm = keys[i] + ";" + allActiveAlarmDpesToTimestampTmp[keys[i]];
    dynAppend(activeAlarms, alarm);
  }    

  
  dyn_string alarmsOccurrances;
  dyn_string keys = mappingKeys(alarmToOccurrancesTmp);
  for (int i=1; i<= dynlen(keys); i++)
  {
    string alarm = keys[i] + ";" + alarmToOccurrancesTmp[keys[i]];
    dynAppend(alarmsOccurrances, alarm);
  }    
  
  dpSet(FWSYSOVERVIEW_NOTIFICATION_ACTIVEALARMS_DPE, activeAlarms,
        FWSYSOVERVIEW_NOTIFICATION_ALARMSOCCURRANCES_DPE, alarmsOccurrances,
        FWSYSOVERVIEW_NOTIFICATION_HEARTBEAT_DPE, getCurrentTime());
}

void _fwSysOverviewNotifications_configChangedCB(string cycleTimeDp, int cycleTimeVal,
                     string alarmActivePeriodDp, int alarmActivePeriodVal,
                     string alarmRenotificationPeriodDp, int alarmRenotificationPeriodVal,
                     string alarmOccurrancesLimitDp, int alarmOccurrancesLimitVal,
                     string alarmOccurrancesPeriodDp, int alarmOccurrancesPeriodVal,
                     string alarmOccurrancesRenotificationPeriodDp, int alarmOccurrancesRenotificationPeriodVal)
{
  cycleTime = cycleTimeVal;
  alarmActivePeriod = alarmActivePeriodVal;
  alarmRenotificationPeriod = alarmRenotificationPeriodVal;
  alarmOccurrancesLimit = alarmOccurrancesLimitVal;
  alarmOccurrancesPeriod = alarmOccurrancesPeriodVal;
  alarmOccurrancesRenotificationPeriod = alarmOccurrancesRenotificationPeriodVal;
}

fwSysOverviewNotifications_sendSummary(dyn_string summaryText, dyn_string dpes, string tree)
{
  string overviewDp = smsConfigDpPrefix + "OVERVIEW_" + strtoupper(tree);
  if (dpExists(overviewDp))
  {
    string recipients;
    bool active;
    dpGet(overviewDp + ".recipients", recipients,
          overviewDp + ".active", active);
    if (active)
    {
      string text;
      fwGeneral_dynStringToString(summaryText, text, " ; ");
      fwSysOverviewNotifications_sendNotification("", text, dpes, recipients);
    }
  }
  else
  {
    DebugN("(Notifications) Summary dp doesn't exist: " + overviewDp);
  }
}



fwSysOverviewNotifications_sendNotification(string application, string smsText, dyn_string dpes, string recipients = "")
{
  bool active = true;
  if (recipients == "")
  {
    string  smsConfigDp = smsConfigDpPrefix + strtoupper(application);
    dpGet(smsConfigDp + ".recipients", recipients,
          smsConfigDp + ".active", active);
  }  

  if (!active)
    return;  

//begin
  if(application == "MOON")
  {
    if (dynContains(dpes, "moon_300:FMC/CS-CCR-MONI/Process/MonitoredProcesses/PVSS00ui_2.readings.state") || dynContains(dpes, "moon_300:FMC/CS-CCR-MONI/Process/MonitoredProcesses/PVSS00ui_3.readings.state"))
    {
      //DebugN("calling: sh /home/unicryo/PVSS_projects/MOON/MOON/data/restartScreenshots.sh");
      system("sh /home/unicryo/PVSS_projects/MOON/MOON/data/restartScreenshots.sh");
    }
    else if (dynContains(dpes, "moon_300:_unSystemAlarm_DPE_fwSysOverviewNotificationsHeartbeat.alarm"))
    {
      //restart manager
      fwInstallationManager_command("RESTART", "PVSS00ctrl", "fwSystemOverview/fwSystemOverviewNotifications.ctl");
    }
   
  }    
//end  
  
  //take the subscriptions
  if(strpos(recipients, ICE_PIQUET_EMAIL) >=0)
  {
    string subscriptions = fwSysOverviewNotifications_getSubscriptions();
    recipients += subscriptions ;
    _fwSysOverviewNotifications_clearOldSubscriptions();
  }
  
  string smtpServer;
  string name;   
  string sender;
  string subject = "Alarms!";
  fwSysOverviewReport_getDefaultEmailConfig(sender, smtpServer, name);
  dyn_string email;
  email[1] = recipients;
  email[2] = sender;
  email[3] = subject;
  email[4] = smsText;
  int ret;
  emSendMail(smtpServer, name, email, ret);
  if (ret != -1)
  {
    string dpesStr;
    fwGeneral_dynStringToString(dpes, dpesStr, ";");
    dpSet("fwSystemOverviewSentEmailsLog.recipients", recipients,
          "fwSystemOverviewSentEmailsLog.emailText", smsText,
          "fwSystemOverviewSentEmailsLog.time", getCurrentTime(),
          "fwSystemOverviewSentEmailsLog.alarmsDpes", dpesStr);
  }
}
string fwSysOverviewNotifications_getSubscriptions()
{
  string subscribers;
  string subscriptions;
  fileToString(ICE_SUBSCRIPTIONS_FILEPATH, subscriptions);
  dyn_string lines = strsplit(subscriptions, "\n");
  if (dynlen(lines) > 0)
  {
    dyn_string lineArr;
    for(int i=1; i<=dynlen(lines);i++)
    {
      lineArr = strsplit(lines[i], "|");
      if(dynlen(lineArr) > 1)
      {
        time t = _fwSysOverviewNotifications_stringToTime(lineArr[2]);
        if((int)t - (int)getCurrentTime() > 0) //date in the future
        {
          subscribers += ";" + lineArr[1];
        }
      }
    }
  }
  return subscribers;
}

void _fwSysOverviewNotifications_clearOldSubscriptions(int timePeriod = 604800) //one week by default
{
  string currentSubscriptions;
  string newSubscriptions; // will contain the subscriptions that are stil valid or they are not valid but timePeriod hasn't passed since when they were valid
  fileToString(ICE_SUBSCRIPTIONS_FILEPATH, currentSubscriptions);
  dyn_string lines = strsplit(currentSubscriptions, "\n");
  if (dynlen(lines) > 0)
  {
    dyn_string lineArr;
    for(int i=1; i<=dynlen(lines);i++)
    {
      lineArr = strsplit(lines[i], "|");
      if(dynlen(lineArr) > 1)
      {
        time t = _fwSysOverviewNotifications_stringToTime(lineArr[2]);
        if((int)t - (int)getCurrentTime() + timePeriod > 0) //timePeriod hasn't passed since the subscription was valid;
        {
          newSubscriptions += lines[i]+"\n";
        }
      }
    }
  }
  file f = fopen(ICE_SUBSCRIPTIONS_FILEPATH, "w+");
  fputs(newSubscriptions, f );
  fclose(f);
}
//timeStr  should be yyyy[./ -]mm[./ -]dd or dd[./ -]mm[./ -]yyyy
time _fwSysOverviewNotifications_stringToTime(string timeStr)
{
  time t;
  dyn_string tmp = strsplit(timeStr, "- ./");
  if(dynlen(tmp) == 3)
  {
    //check whether the year is first or last
    if (strlen(tmp[1])==4)
    {
      t = makeTime(tmp[1], tmp[2], tmp[3], 23, 59, 59);
    }
    else
    {
      t = makeTime(tmp[3], tmp[2], tmp[1], 23, 59, 59);
    } 
    
  }
  return t;
}  
void fwSysOverviewNotifications_sendAdditionalNotifications(string application, string dpe, string text, bool& additionalNotificationConfigured)
{
  additionalNotificationConfigured = false;
  string systemName = dpSubStr(dpe, DPSUB_SYS); 
  string recipients = fwSysOverviewNotifications_getAlarmRecipients(application, systemName, dpe);

  if (recipients != "")
  {
    additionalNotificationConfigured = true;
    fwSysOverviewNotifications_sendNotification(application, text, makeDynString(dpe), recipients);
  }
}

bool fwSysOverviewNotifications_shouldInhibitAlarm(string application, string dpe, time currentTime)
{
  bool shouldInhibit = false;
  
  //check if the alarm is locally masked
  bool isMasked;
  string masked;
  if(dpExists(dpe + ":_general" + fwSystemOverview_MASKED_DPCONFIG))
    dpGet(dpe+ ":_general" + fwSystemOverview_MASKED_DPCONFIG, masked);  
  //if this alarm should not be followed by the SBS do nothing
  isMasked = (masked == "YES");
  
  // first check if the alarm has been configured for notification
  string alertNotificationConfigDpe = dpe + ":" + fwConfigs_PVSS_GENERAL + fwSystemOverview_SMS_DPCONFIG;
  string sendNotification = "NO";
  

  if(dpExists(alertNotificationConfigDpe))
  {
    dpGet(alertNotificationConfigDpe, sendNotification);
  }
  
  if (!isMasked && (sendNotification == "YES" || !shouldCheckAlarmAttribute))
  {
    string dpelement = dpSubStr(dpe, DPSUB_SYS_DP_EL);
    string  smsConfigDp = smsConfigDpPrefix + strtoupper(application);
    if (dpExists(smsConfigDp))
    {
      string patterns;
      string inhibitUntilStr;
      bool active;
      dpGet(smsConfigDp + ".inhibitPatterns", patterns,
            smsConfigDp + ".inhibitUntil", inhibitUntilStr,
            smsConfigDp + ".active", active);
      dyn_string inhibitDates = strsplit(inhibitUntilStr, ";");
      if (active)
      {
        dyn_string inhibitPatterns = strsplit(patterns, ";");
        for(int i=1; i<= dynlen(inhibitPatterns); i++)
        {
          if (patternMatch(inhibitPatterns[i], dpelement))
          {
            time inhibitTime = (time) inhibitDates[i];
            if (inhibitTime == 0 || inhibitTime > currentTime)//check the date
            {
              shouldInhibit = true;
              break;
            }
          }
        }
    
      }
      else 
      {
        shouldInhibit = true;
      }
    }
  }
  else
  {
    shouldInhibit = true;
  }
  return shouldInhibit;
}

void fwSysOverviewNotifications_checkBufferForOccurrances(time currentTime, mapping& applicationToText, mapping& applicationToDpes) synchronized(alarmToOccurrances)
{
  dyn_string alarmsDpes = mappingKeys(alarmToOccurrances);
  dyn_string alarmsToRemoveFromBuffer;
  for (int i=1; i<= dynlen(alarmsDpes); i++)
  {
    
    
    string alarmsTimesStr = alarmToOccurrances[alarmsDpes[i]];
    dyn_string alarmTimes = strsplit(alarmsTimesStr, ";");
    // the second element of the array is the number of occurrances
    //TODO indexes as constants
    int alarmOccurrances = (int) alarmTimes[2];
    string timeLastNotificationSent = alarmTimes[1];
    dynRemove(alarmTimes, 2);
    dynRemove(alarmTimes, 1);    
    if (dynlen(alarmTimes) == alarmOccurrances)
    {
      dyn_string newAlarmTimes;
      int timePassed;
      for(int j=1; j <= dynlen(alarmTimes) ; j++)
      {
        timePassed = currentTime - alarmTimes[j];
        if (timePassed <= alarmOccurrancesPeriod)
        {
          dynAppend(newAlarmTimes, alarmTimes[j]);
        }
        else
        {
          alarmOccurrances--;
        }
      }
      if (alarmOccurrances == 0)
      {
        dynAppend(alarmsToRemoveFromBuffer, alarmsDpes[i]);
        continue;
      }
      //update the buffer
      string newAlarmTimesStr;
      fwGeneral_dynStringToString(newAlarmTimes, newAlarmTimesStr, ";");
      if (alarmOccurrances >= alarmOccurrancesLimit)
      {
        // check how much time has passed since the last time this notification was sent
        int timeSinceLastNotification = -1;
        
        if (timeLastNotificationSent != "")
        {
          timeSinceLastNotification = currentTime - (time) timeLastNotificationSent;
        }
        // if notification hasn't been sent or the time passed is enough and the alarm should not be inhibited
        if (timeSinceLastNotification == -1 || timeSinceLastNotification > alarmOccurrancesRenotificationPeriod)
        {
          string dpIdentifier = fwSysOverview_getDpeIdentifier(alarmsDpes[i]);
          string text = "Alarm "  + dpIdentifier + " occured " + alarmOccurrances + " times for the last " + _fwSysOverviewNotifications_convertSecondsToHoursString(alarmOccurrancesPeriod) +"(dpe:" +alarmsDpes[i] + "); ";
          string alarmApplication;
          if (dpSubStr(alarmsDpes[i], DPSUB_SYS) != getSystemName())
          {
            alarmApplication = systemNameToApplication[dpSubStr(alarmsDpes[i], DPSUB_SYS)];
          }
          else
          {
            fwSysOverviewNotifications_getApplication(alarmsDpes[i], alarmApplication);
          }
          bool notificationAddedToApp;          
          if (!fwSysOverviewNotifications_shouldInhibitAlarm(alarmApplication, alarmsDpes[i], currentTime))
          {          
            if (mappingHasKey(applicationToText, alarmApplication))
            {
              string currentText = applicationToText[alarmApplication];
              applicationToText[alarmApplication] = currentText + text;
            }
            else
            {
              applicationToText[alarmApplication] = text;
            }
          
            if (mappingHasKey(applicationToDpes, alarmApplication))
            {
              string currentDpes = applicationToDpes[alarmApplication];
              applicationToDpes[alarmApplication] = currentDpes + ";" + alarmsDpes[i];
            }
            else
            {
              applicationToDpes[alarmApplication] = alarmsDpes[i];
            }
            notificationAddedToApp = true;
          }
        
          bool additionalNotificationConfigured;
          fwSysOverviewNotifications_sendAdditionalNotifications(alarmApplication, alarmsDpes[i], text, additionalNotificationConfigured);
          if (notificationAddedToApp || additionalNotificationConfigured)
          {
            // save that notificaiton for this alarm is sent
            timeLastNotificationSent = (string) currentTime;
          }
        }
      }
      
      alarmToOccurrances[alarmsDpes[i]] = timeLastNotificationSent + ";" + alarmOccurrances + ";" + newAlarmTimesStr;
      
     
    }
    else
    {
      DebugN("Incorrect data in occurrances buffer. Occurrances: " + alarmOccurrances + " Times: " + alarmTimes);
    }
  }
  
  // remove from the buffer all alarms for which there are no more occurrances during the last alarmOccurrancesPeriod
  for (int i=1; i<= dynlen(alarmsToRemoveFromBuffer); i++)
    mappingRemove(alarmToOccurrances, alarmsToRemoveFromBuffer[i]);
  
//  //DebugN("Occurrances buffer checked. Current content: " + alarmToOccurrances);
}

string _fwSysOverviewNotifications_convertSecondsToHoursString(int seconds)
{
  int h = seconds/(60*60);
  int minutes = (seconds % (60*60))/60;
  string hoursStr = h+"h";
  if (minutes>0)
    hoursStr += " and " + minutes + "minutes";
  
  return hoursStr;
}

bool _fwSysOverviewNotifications_isTimeForNotification(string dpe, time alarmCame, time iterationStartTime)
{
  int timePassed = iterationStartTime - alarmCame;//seconds

  
  bool timeForNotifiation = (timePassed >= alarmActivePeriod && timePassed < (alarmActivePeriod + cycleTime)); 


  //do not send re-notifications outside of working hours:
  time now = getCurrentTime();
  int hNow = hour(now);
  
  if(20 < hNow || hNow > 8)
  {
    if (!timeForNotifiation) // check whether it is time for re-notification
    {
       int mod = timePassed % alarmRenotificationPeriod;
       timeForNotifiation = timePassed >= alarmRenotificationPeriod && mod < cycleTime;
    }
  }
  return timeForNotifiation;
}
dyn_string fwSysOverviewNotifications_checkAlarmsForNotifications(string application, dyn_dyn_anytype activeAlarms,time currentTime, string& text)
{
  dyn_string dpes;
  string notificationText, renotificationText;
  int alarmsCount = 0;
  int alarmsRenotificaitonCount = 0;
  int timePassed;
  bool additionalNotificationConfigured;
  
  for (int i=1; i<= dynlen(activeAlarms); i++)
  {
    //TODO put indexes in constants
    time alarmTS = activeAlarms[i][2];
    timePassed = currentTime - alarmTS;//seconds
    ////DebugN("t " + timePassed);
//    int timeSinceCycleStart = getCurrentTime() - currentTime;

    if (timePassed >= alarmActivePeriod && timePassed < (alarmActivePeriod + cycleTime))
    {

      string dpIdentifier = fwSysOverview_getDpeIdentifier(activeAlarms[i][1]);
      string alarmNotificationText = "Desc: " + dpIdentifier + " TIME: " +activeAlarms[i][2] + " TEXT: " + activeAlarms[i][3] + " VALUE:"+activeAlarms[i][4] + " DPE:" + activeAlarms[i][1] +";\n ";
      if (!fwSysOverviewNotifications_shouldInhibitAlarm(application, activeAlarms[i][1], currentTime) )
      {
        alarmsCount++;
        notificationText += alarmsCount + ". " + alarmNotificationText;
        string tmp = activeAlarms[i][1];
        dynAppend(dpes, tmp);
      }
      
      fwSysOverviewNotifications_sendAdditionalNotifications(application, activeAlarms[i][1], "New alarm: " + alarmNotificationText, additionalNotificationConfigured);
    }
    
    int mod = timePassed % alarmRenotificationPeriod;
    if (timePassed >= alarmRenotificationPeriod && mod < cycleTime)
    {
      string dpIdentifier = fwSysOverview_getDpeIdentifier(activeAlarms[i][1]);
      string alarmRenotificationText =  "DPE: " + activeAlarms[i][1] + "(" + dpIdentifier + ")\n ";
      if (!fwSysOverviewNotifications_shouldInhibitAlarm(application, activeAlarms[i][1], currentTime) )
      {
        alarmsRenotificaitonCount++;
        renotificationText += alarmsRenotificaitonCount + ". " + alarmRenotificationText;
        string tmp = activeAlarms[i][1];
        dynAppend(dpes, tmp);      
      }
      fwSysOverviewNotifications_sendAdditionalNotifications(application, activeAlarms[i][1], "Alarm active more than "+_fwSysOverviewNotifications_convertSecondsToHoursString(alarmRenotificationPeriod) + ": " + alarmRenotificationText, additionalNotificationConfigured);
    }
    
  }
  
  if ( alarmsCount > 0)
  {
    notificationText = alarmsCount + " new alarms!" + notificationText;
  }
  if (alarmsRenotificaitonCount > 0)
  {
    renotificationText = alarmsRenotificaitonCount + " alarms active more than "+_fwSysOverviewNotifications_convertSecondsToHoursString(alarmRenotificationPeriod) + ": " + renotificationText;

  }
  
 text = notificationText + renotificationText;

 return dpes;
}

//returns a list with the active  alarms Column1->dpe, Column2->timestamp, Column3->AlarmText, Column4->Alarm value
dyn_dyn_anytype fwSysOverviewNotifications_getApplicationActiveAlarmsFromBuffer(string application, time iterationStart) synchronized(activeAlarmDpeToTimestamp)
{
  dyn_dyn_string alarms;
  int index =1;
  dyn_string localNotActiveAlarmsKeys;
  dyn_string dpes = mappingKeys(activeAlarmDpeToTimestamp);
  
  for (int i=1; i<= dynlen(dpes); i++)
  {
    string systemName = dpSubStr(dpes[i], DPSUB_SYS);
    // if this is local (moon_300:) alarm first we should check whether it is still active
    // and if it isn't we should remove it from the buffer at the end of the cycle
    if (systemName == "moon_300:")    
    {
      bool active;
 
      dpGet(dpes[i] + ":_alert_hdl.._act_state", active);

      if (!active)
      {
        string dp = dpes[i];
        dynAppend(localNotActiveAlarmsKeys, dp);
        continue;
      }
    }
    
    //check that the fsm device is still enabled in the tree otherwise remove this alarm from the buffer:
    if(fwSysOverviewNotifications_fsmDeviceExists(dpes[i]) && !fwSysOverviewNotifications_isFsmDeviceEnabled(application, dpes[i]))
    {
        string dp = dpes[i];
        dynAppend(localNotActiveAlarmsKeys, dp);
        continue;
    }

    
    if (mappingHasKey(systemNameToApplication, systemName) || systemName == "moon_300:")
    {              
      string alarmDetailsStr = activeAlarmDpeToTimestamp[dpes[i]];
      dyn_string alarmDetails = strsplit(alarmDetailsStr, ";");
      if (dynlen(alarmDetails) == 3 )
      {

        if ( _fwSysOverviewNotifications_isTimeForNotification(dpes[i], alarmDetails[1], iterationStart))
        {
          string app;
          if (systemName != getSystemName())
            app = systemNameToApplication[systemName];
          else
          {
            fwSysOverviewNotifications_getApplication(dpes[i], app);
          }
          if (app != application || app == "")
            continue;
          // SI alarm for this application
          alarms[index][1] = dpes[i];
          alarms[index][2] = alarmDetails[1];        
          alarms[index][3] = alarmDetails[2];                
          alarms[index][4] = alarmDetails[3];    
          index++;        
        }
      }
      else
      {
        DebugN("Incorrect data in buffer: " + alarmDetailsStr);
      }
    }
    else
    {
      DebugN("Unknown system name: " + systemName);
    }
  }
  
  //clear from the buffer all local alarms that are not active anymore
  for (int i=1; i<=dynlen(localNotActiveAlarmsKeys); i++)
  {
    if(patternMatch("moon_300:*", localNotActiveAlarmsKeys[i]))
    {
      mappingRemove(activeAlarmDpeToTimestamp, localNotActiveAlarmsKeys[i]);
      mappingRemove(allActiveAlarmDpesToTimestamp, localNotActiveAlarmsKeys[i]);
    }
  }
  
  ////DebugN("Checked for  alarms of " + application + ". Result: " + alarms);
  return alarms;
}

//returns a list with the currently active alarms, and the alarms that came since last time: Column1->dpe, Column2->timestamp, Column3->AlarmText, Column4->Alarm value
dyn_dyn_anytype fwSysOverviewNotifications_addLocalActiveAlarmsToBuffer(time currentTime)
{
  time start = currentTime -  cycleTime;
  dyn_string dpesPresentlyInAlarm;
  string startStr = start;
  string endStr = currentTime;
  string  query = "SELECT ALERT '_alert_hdl.._text', '_alert_hdl.._abbr', '_alert_hdl.._value', '_alert_hdl.._sum', '_alert_hdl.._direction' FROM '*.**' " + " TIMERANGE(\""+startStr+"\",\"" + endStr + "\",1,0)";
  dyn_dyn_anytype recordsHistory;
  string dpe, text, value, ts;
  dpQuery(query, recordsHistory);
  
  string queryActive =  "SELECT ALERT '_alert_hdl.._text', '_alert_hdl.._abbr', '_alert_hdl.._value', '_alert_hdl.._sum', '_alert_hdl.._direction' FROM '*.**' ";
  dyn_dyn_anytype recordsActive;
  dpQuery(queryActive, recordsActive);
  dyn_dyn_anytype records;  
  dynAppend(records, recordsHistory);
  dynAppend(records, recordsActive); 
  
  for(int i = 2; i <= dynlen(records); i++)
  {
    bool isSummary = (bool)records[i][6];
    if(isSummary)
      continue;

    bool isCame = (bool) records[i][7];
    if(!isCame)
      continue;

//add the alarm to the buffer of active alarms if not yet in there:
    //Ignore alarm if
    // * the alarm is locally masked (MOON Specific)
    // * the alarm is locally hidden (MOON Specific)
    
    bool masked = false, hidden = false;
    bool deviceDisabled = false;
    
    if(isFunctionDefined("icemon_getAlarmHiddenLocally"))
    {
      hidden = icemon_getAlarmHiddenLocally(dpe);
      masked = icemon_getAlarmMaskedLocally(dpe);
    }
    
    if(hidden || masked)
    {
      continue;
    }


        
    
    string row1 = records[i][1];
    dyn_string ds = strsplit(row1, " ");
    dpe = ds[1];
    dynAppend(dpesPresentlyInAlarm, dpe);
    
    string row2 = records[i][2];
    ts = substr(row2, 0, 30);
    text = (string) records[i][3];
    value = records[i][5];
    string application;
    
    fwSysOverviewNotifications_getApplication(dpe, application);
    
    // * check the device is enabled before adding the alarm to the buffer
    //check that the fsm device is enable in the tree otherwise ignore this alarm:
    if(fwSysOverviewNotifications_fsmDeviceExists(dpe) && !fwSysOverviewNotifications_isFsmDeviceEnabled(application, dpe))
    {
      continue;
    }

    
    bool alarmAddedToBuffer = mappingHasKey(allActiveAlarmDpesToTimestamp, dpe);
    if(!alarmAddedToBuffer || (alarmAddedToBuffer && !patternMatch(ts + "*", allActiveAlarmDpesToTimestamp[dpe]))) 
    { 
      if (application != "")
      {
        allActiveAlarmDpesToTimestamp[dpe] = ts + ";" + text + ";" + value;
      }
    else
    {
      //DebugN("Cannot find application for " + dpe);    
    }
   }


  //now fill the buffer of the alarms that trigger a notification

    //if no notification flag is set, ignore the alarm
    string str = records[i][1];
    dyn_string ds = strsplit(str, " ");
    string dp =  ds[1] + ":_general.._string_04";
    string notification = "NO";

    if(dpExists(dp))
    {
      dpGet(dp , notification);
    }

    
    if(strtoupper(notification) != "YES")
    {
      continue;
    } 
    
  
    int timePassed = currentTime - ts;
    bool alarmAddedToBuffer = mappingHasKey(activeAlarmDpeToTimestamp, dpe);
    // if the alarm is not yet added to the buffer or it is added but with a different timestamp
    
  if(!alarmAddedToBuffer || (alarmAddedToBuffer && !patternMatch(ts + "*", activeAlarmDpeToTimestamp[dpe]))) 
    { 
      if (application != "")
      {
        activeAlarmDpeToTimestamp[dpe] = ts + ";" + text + ";" + value;

        if (mappingHasKey(alarmToOccurrances, dpe))
        {
          string alarmString = alarmToOccurrances[dpe];
          dyn_string arr = strsplit(alarmString, ";");
          int occurrances = (int) arr[2] + 1; //TODO add indexes as constants
          arr[2] = occurrances;
          arr[dynlen(arr)+1]  = ts;
          string newAlarmString;
          fwGeneral_dynStringToString(arr, newAlarmString, ";");
          alarmToOccurrances[dpe] = newAlarmString;
        }
        //else add it and set the counter to 1
        else
        {
          string alarmString = ";1;" + ts;
          alarmToOccurrances[dpe] = alarmString;
        }
      }
    else
    {
      //DebugN("Cannot find application for " + dpe);    
    }
  }
}
  
  //clean buffers from old local alarms. Note that the array dpesPresentlyInAlarm only contains moon alarms. 
  dyn_string allActiveAlarmDpes = mappingKeys(allActiveAlarmDpesToTimestamp);
  int n = dynlen(allActiveAlarmDpes);
  for(int i = 1; i <= n; i++)
  {
    if(dynContains(dpesPresentlyInAlarm, allActiveAlarmDpes[i]) <= 0 && patternMatch("moon_300:*", allActiveAlarmDpes[i]))
    {
      mappingRemove(allActiveAlarmDpesToTimestamp, allActiveAlarmDpes[i]);
      mappingRemove(activeAlarmDpeToTimestamp, allActiveAlarmDpes[i]);
    }
  }  
  
  dyn_string dsTs = mappingKeys(activeAlarmDpeToTimestamp);
  dyn_string dsOcc = mappingKeys(alarmToOccurrances);
  
}

void _fwSysOverviewNotifications_connectedSystemsChangedCB(string connectedSystemsDpe, dyn_int connectedSystemsIds)
{
 
  // for each of the systems 
  for (int i=1; i<= dynlen(connectedSystemsIds); i++)
  {
    int sysId = connectedSystemsIds[i];
    //if the system is newly connected
    if(!dynContains(connectedSystems, sysId))
    {
      string systemName = getSystemName(sysId);
      string systemStr = systemName + "_"  + sysId;
      
      strreplace(systemStr, ":", "");
      string dpName =  "moon_300:icemonSystemIntegrity_" + strtoupper(systemStr);
      if (dpExists(dpName))
      {
        string application;
        
        fwSysOverviewNotifications_getApplication(dpName, application);
        systemNameToApplication[systemName] = application;
        //dpConnect to the state of the summary alert - _fwSysOverviewNotifications_summaryAlarmStateChangedCB
        dpConnect("_fwSysOverviewNotifications_summaryAlarmStateChangedCB", dpName + ".alarm");
        dynAppend(connectedSystems, sysId);
        
      }
      else 
      {
        DebugN("fwSystemOverviewNotifications.ctl lib, _fwSysOverviewNotifications_connectedSystemsChangedCB: Dp doesn't exist: " + dpName);
      }
    }
    else
    {
      ////DebugN("Already coonected: " + sysId);
    }
  }
  
  //remove the systems that are not connected anymore from connectedSystems variable
  for(int i=1; i<= dynlen(connectedSystems);i++)
  {
    int pos = dynContains(connectedSystemsIds, connectedSystems[i]);
    if (pos == 0)
      dynRemove(connectedSystems, pos);
  }
  
}

void _fwSysOverviewNotifications_summaryAlarmStateChangedCB(string summaryAlarmDp, bool state) synchronized(connectedSummaryAlerts) 
{
  //get the _UnApplication dp
  string unAppDp;
  string sys = dpSubStr(summaryAlarmDp, DPSUB_SYS);
  
  dpGet(dpSubStr(summaryAlarmDp, DPSUB_SYS_DP) + ".systemIntegrityDP", unAppDp);
  dyn_string dpes;
  dpGet(unAppDp + ".applicationName:_alert_hdl.._dp_list", dpes);
  int positionConnected = dynContains(connectedSummaryAlerts, dpSubStr(unAppDp, DPSUB_SYS_DP));

  if (state && positionConnected <= 0)
  {
    //fwInstallation_throw("Summary alarm active -> Dp connect to all alarms: " + dpSubStr(unAppDp, DPSUB_SYS_DP));
    for(int i=1; i<= dynlen(dpes); i++)
    {
      if (!dynContains(failedDpDisconnects, dpes[i]))
      {
        int err = dpConnect("_fwSysOverviewNotifications_alarmCB", dpes[i] + ":_alert_hdl.._act_state");
//         if(!err)
//           fwInstallation_throw("***Successfully connected to dpe: " + dpes[i]);
      }
      else
        dynRemove(failedDpDisconnects, dpes[i]); //remove after the first dpConnect to the dplist of this summary alert

    }
    dynAppend(connectedSummaryAlerts, dpSubStr(unAppDp, DPSUB_SYS_DP));
  }
  else if (!state && positionConnected > 0)
  { 
    //Remove the alarms from the global mappings if any:
    _fwSystemOverviewNotifications_removeSystemAlarmsFromBuffers(sys);
    //fwInstallation_throw("Summary alarm not active -> Dp disconnect from all alarms: " + dpSubStr(unAppDp, DPSUB_SYS_DP));
    for(int i=1; i<= dynlen(dpes); i++)
    {
      int err = dpDisconnect("_fwSysOverviewNotifications_alarmCB", dpes[i] + ":_alert_hdl.._act_state");
      if(err)
      {
        dynAppend(failedDpDisconnects, dpes[i]);
        //fwInstallation_throw("<<<<<<<Failed to disconnected from dpe: " + dpes[i]);
      }
           
    }
    dynRemove(connectedSummaryAlerts, positionConnected);
  }
}

void _fwSystemOverviewNotifications_removeSystemAlarmsFromBuffers(string sys){
  
  dyn_string dpes = mappingKeys(allActiveAlarmDpesToTimestamp);

  int n = dynlen(dpes);
  for(int i = 1; i<= n; i++){
    if(patternMatch(sys + "*", dpes[i])) //Found an alarm in the buffer which belongs to the system that has been disconnected.
    {
//      DebugTN(__FILE__ + " - " + __FUNCTION__ + ": Found alarm DPE from a disconnected system in allActiveAlarmDpesToTimestamp buffer, DPE: " + dpes[i] + " - system: " + sys);
      mappingRemove(allActiveAlarmDpesToTimestamp, dpes[i]);
    }
  }
  
  dpes = mappingKeys(activeAlarmDpeToTimestamp);

  n = dynlen(dpes);
  for(int i = 1; i<= n; i++){
    if(patternMatch(sys + "*", dpes[i])) //Found an alarm in the buffer which belongs to the system that has been disconnected.
    {
//      DebugTN(__FILE__ + " - " + __FUNCTION__ + ": Found alarm DPE from a disconnected system in activeAlarmDpeToTimestamp buffer, DPE: " + dpes[i] + " - system: " + sys);
      mappingRemove(activeAlarmDpeToTimestamp, dpes[i]);
    }
  }
  fwSysOverviewNotifications_copyAlarms();

  return;
}

void _fwSysOverviewNotifications_alarmCB(string alarmDp, bool active)
{
//DebugN("Executing: " + __FUNCTION__ + " for " + alarmDp + " - active: " + active);
  string dpe = dpSubStr(alarmDp, DPSUB_SYS_DP_EL);
  // check whether this is an SBS alarm
  string masked;
  if(dpExists(dpe + ":_general" + fwSystemOverview_MASKED_DPCONFIG))
    dpGet(dpe+ ":_general" + fwSystemOverview_MASKED_DPCONFIG, masked);  
  //if this alarm should not be followed by the SBS do nothing
  if (masked == "YES")
    return;
  if (active)
  {
    //get the time of the alarm
    time t; 
    string text, value;
    dpGet(dpe + ":_original.._stime", t,
          dpe + ":_alert_hdl.._act_text", text,
          dpe + ":_original.._value", value);
    // add the alarm to activeAlarmDpeToTimestamp(key dpe)
//    DebugTN(__FILE__ + " - " + __FUNCTION__ + ": Adding remote alarm to buffers:" + dpe, (string)t+";"+text+";"+value);    

    activeAlarmDpeToTimestamp[dpe] = (string)t+";"+text+";"+value; //buffer of alarms that trigger notifications.
    allActiveAlarmDpesToTimestamp[dpe] = (string)t+";"+text+";"+value; // buffer containing all alarms regardles the notification flag
    //if alarmToOccurrances has for key this alarm -> increase its counter
    if (mappingHasKey(alarmToOccurrances, dpe))
    {
      synchronized(alarmToOccurrances)
      {
        string alarmString = alarmToOccurrances[dpe];
        dyn_string arr = strsplit(alarmString, ";");
        int occurrances = (int) arr[2] + 1;
        arr[2] = occurrances;
        arr[dynlen(arr)+1]  = t;
        string newAlarmString;
        fwGeneral_dynStringToString(arr, newAlarmString, ";");
        alarmToOccurrances[dpe] = newAlarmString;
      }
    }
    //else add it and set the counter to 1
    else
    {
      string alarmString = ";1;" + (string)t;
      alarmToOccurrances[dpe] = alarmString;
    }
  }
  else //the alarm is not active anymore
  {
    synchronized(activeAlarmDpeToTimestamp)
    {
      // remove the alarm from activeAlarmDpeToTimestamp
//      DebugTN(__FILE__ + " - " + __FUNCTION__ + ": Removing from activeAlarmDpeToTimestamp buffer an alarm which is not active anymore, DPE: " + dpe);
      mappingRemove(activeAlarmDpeToTimestamp, dpe);
    }
    
    synchronized(allActiveAlarmDpesToTimestamp)
    {
      // remove the alarm from allActiveAlarmDpesToTimestamp
//      DebugTN(__FILE__ + " - " + __FUNCTION__ + ": Removing from allActiveAlarmDpesToTimestamp buffer an alarm which is not active anymore, DPE: " + dpe);
      mappingRemove(allActiveAlarmDpesToTimestamp, dpe);
    }
    
  }
  ////DebugN("alarmCB: " + alarmToOccurrances);
  fwSysOverviewNotifications_copyAlarms();
}

bool fwSysOverviewNotifications_fsmDeviceExists(string fsmDp)
{
  string oldFsmDp = fsmDp;
  fsmDp = fwSysOverviewNotifications_dpSubStr(fsmDp, DPSUB_DP);
  string alias = dpGetAlias(fsmDp + ".");
  
  bool exists;
  dyn_string dps = dpNames("*|" + fsmDp, "_FwFsmDevice");
  exists = (dynlen(dps) > 0);

  if(!exists) //check if the device was inserted in the FSM tree using its alias
  {
    dyn_string dps = dpNames("*|" + alias, "_FwFsmDevice");
    exists = (dynlen(dps) > 0);
  }
  return exists;
}

//the function dpSubStr(dp, DPSUB_SYS) returns "" if the UI is not started as a distributed  UI. This function overcomes this problem by always returning the system name of the dp, no matter how the UI was started.
string fwSysOverviewNotifications_dpSubStr(string dp, string pattern)
{
  if(pattern == DPSUB_SYS)
  {
    int pos = strpos(dp, ":");
    if(pos <= 0)
    {
      return "";
    }
     return substr(dp, 0, pos + 1);
  }
  else if(pattern == DPSUB_SYS_DP)
  {
    int pos = strpos(dp, ".");
    if(pos <= 0)
    {
      return dp;
    }
    return substr(dp, 0, pos);
  }
  else if(pattern == DPSUB_DP)
  {
    int pos1 = strpos(dp, ":");
    dp = substr(dp, pos1+1, strlen(dp)); //get rid of the system name first
    
    int pos2 = strpos(dp, ".");
    
    if(pos2 <= 0)
    {
      pos2 = strlen(dp); //drop all that comes after the .
    }

    return substr(dp, 0, pos2);
  }
  
}

string fwSysOverviewNotifications_getFsmDp(string dp)
{
  string fmcPattern = "FwFMC*";
   
  string fsmDp;
  
   //if this is dp for another system replace it with the local icemonSystemIntegrity dp
  string systemName = fwSysOverviewNotifications_dpSubStr(dp, DPSUB_SYS);
  string fwSoSystem = "moon_300:";
  int id = getSystemId(systemName);

  if(systemName != fwSoSystem)//if it is not a local dp, we use the system integrity dp.
  {
    string sys = systemName;
    strreplace(sys, ":", "");
    string dpPattern = fwSoSystem + "icemonSystemIntegrity_" + strtoupper(sys) + "_*";
    dyn_string matchingDps = dpNames(dpPattern, "IcemonSystemIntegrity");
    
    if(dynlen(matchingDps) <= 0)
    {
      
      return "";
    }
    
    fsmDp = matchingDps[1];
    return fsmDp; 
  }


  
  string dpType = dpTypeName(fwSysOverviewNotifications_dpSubStr(dp, DPSUB_SYS_DP));
  
  dyn_errClass err = getLastError();
  if(dynlen(err) > 0)
  {
    DebugN("Could not resolve DP type for dp: ", dp, fwSysOverviewNotifications_dpSubStr(dp, DPSUB_SYS_DP));
  }  

  if (dpType == "IcemonSystemIntegrity" || dpType == "FwFMCNode" || dpType == "FwSystemOverviewProject" || dpType == "IcemonDipMonitoring" || dpType == "IcemonDIPDNSMonitoring" || dpType == "IcemonDIPRDBMonitoring" || dpType == "IcemonLicenseGenerator")
  {
    fsmDp = dpSubStr(dp, DPSUB_SYS_DP);
  }
  else if (dpType == "IcemonPlc" || dpType == "IcemonFec" || dpType == "FwWebMonitor_monitoredEntry")
  {
    fsmDp = dpGetAlias(dpSubStr(dp, DPSUB_SYS_DP) + ".");
  }
  else if (patternMatch(fmcPattern, dpType))
  {
    fsmDp = fwFMC_getNodeDp(fwFMC_getNodeName(dpSubStr(dp, DPSUB_SYS_DP)));
    fsmDp = dpSubStr(fsmDp, DPSUB_SYS_DP);
  }
  else if (dpType == "FwSystemOverviewManager")
  {
    dyn_string arr = strsplit(dpSubStr(dp, DPSUB_SYS_DP), "/");
    if (dynlen(arr) == 4)
    {
      if(strpos(arr[1], ":") < 0)
      {
        fsmDp = fwSoSystem + arr[1] + "/" + arr[2] + "/" + arr[3];
      }
      else
      {
        fsmDp = arr[1] + "/" + arr[2] + "/" + arr[3];
      }
    }
  }
  else if(dpType == "_UnSystemAlarm" || dpType == "FwNetMonitorSwitch")
  {
    fsmDp = dp;
  }
  else
  {
    //DebugN(__FILE__ + " " + __FUNCTION__ + " ERROR: Unknown dp-type", dpType, " FSM DP cannot be resolved.");  
    return "";
  }


/*
  else if (dpType == "_UnSystemAlarm" && strpos(dp, c_unSystemAlarm_dpPattern+DPE_pattern) >= 0) // get the IcemonDipMonitoring dp
  {
    fsmDp = dpSubStr(dp, DPSUB_SYS_DP);
    strreplace(fsmDp,  c_unSystemAlarm_dpPattern+DPE_pattern,"");
    
    if (!dpExists(fsmDp) || dpTypeName(fsmDp) != "IcemonDipMonitoring") //not an IcemonDipMonitoring DPE alarm
    {
      dp = fwSoSystem + "icemonSystemIntegrity_" + strtoupper(systemName) + "_" + id;
      fsmDp = dpSubStr(dp, DPSUB_DP);
    }
  }
  else if (patternMatch("*_unSystemAlarm*", dp))
  {
    dp = fwSoSystem + "icemonSystemIntegrity_" + strtoupper(systemName) + "_" + id;
    fsmDp = systemName + dpSubStr(dp, DPSUB_DP);
  }
*/
  return fsmDp;
}

bool fwSysOverviewNotifications_isFsmDeviceEnabled(string dp)
{
  bool enabled = true;
  string fsmDp = fwSysOverviewNotifications_getFsmDp(dp);
  
if (fsmDp != "" && fwSysOverviewNotifications_fsmDeviceExists(fsmDp))
  {
    fsmDp = substr(fsmDp, strpos(fsmDp, ":") + 1, strlen(fsmDp)); //the fsm function, fwUi_getDuModeBits requires that hte device name does not contain the system name
    string domain = fwSysOverviewFsm_getDomain(fsmDp);
    bit32 mode = fwUi_getDUModeBits(domain, fsmDp);
    if(getBit(mode, 0) ||
       getBit(mode, 7))
    {
      enabled = false;
    }
  }
  return enabled;
}

bool fwSysOverviewNotifications_getApplication(string dp,string& application, string subtree = "")
{
  dp = fwSysOverviewNotifications_dpSubStr(dp, DPSUB_SYS_DP);
  if (patternMatch("*dummy*", dp))
    return false;
  bool foundInSubTree = false;

  string rootPattern = "fwSO_*";

//this code does not work now since the MOON UI will not be started as a distributed UI to save resources and make it faster
  
  string fsmDp = fwSysOverviewNotifications_getFsmDp(dp);
  if (fsmDp != "" && fwSysOverviewNotifications_fsmDeviceExists(fsmDp))
  {
     int type;
     string parent;
     string tmp = fsmDp;
     if (subtree != "")
     {
       //untill we reach our subtree or we reach the root
       while (!patternMatch(rootPattern, tmp) && !patternMatch(subtree, tmp) )
       {
  
          parent = tmp;
          tmp = substr(tmp, strpos(tmp, ":") + 1, strlen(tmp)); //get rid of the system name if present.
          tmp = fwCU_getParent(type, tmp);
          //sometime the method getParent returns empty string for unknown reason
          if(tmp == "")
          {
            //DebugN("fwCU_getParent returned empty string for: " + parent);
            break;
          }
       }
       //check with which condition we exited the cycle
       foundInSubTree = patternMatch(subtree, tmp);
     }
     else
     {
       while (!patternMatch(rootPattern, tmp) )
       {
         
          parent = tmp;;
          tmp = substr(tmp, strpos(tmp, ":") + 1, strlen(tmp)); 
          tmp = fwCU_getParent(type, tmp);
       }
       //awlays true
       foundInSubTree = true;
     }
    
     application = parent;
    
  }
  else if(dpTypeName(dp) == "_UnSystemAlarm" && patternMatch("moon_300:*", dp))  //Some dps of MOON do not appear in FSM tree
  {
    application == "MOON";
  }
  else if(dpTypeName(dp) == "FwNetMonitorSwitch")
  {
    application == "MOON";
  }
  else
  {
    //DebugN("fwSystemOverviewNotifications.ctl lib, fwSysOverviewNotifications_getApplication(): DP doesn't exist: " + dp + ", fsmDp:" + fsmDp);
  }
  
  return foundInSubTree;
}
string fwSysOverviewNotifications_getApplicationLabel(string tree, string application)
{
  string label;
  string domain;

  if (fwSysOverviewFsm_isDomain(application))
    domain = application;
  else
    domain = tree;
    
  fwUi_getLabel(domain, application, label);
  
  return label;
}



string fwSysOverviewNotifications_getAlarmNotificationsConfigDp(string application, string systemName, string alarmDp, bool create = false)
{
  string dpName;
  if (alarmDp != "" && application != "" && systemName != "")
  {
    strreplace(systemName, ":", "");
    //ensure it is only dpName, without elements and system
    string dp = dpSubStr(alarmDp, DPSUB_SYS_DP);
    dpName = "Notification/" + application + "/" + systemName + "/" + dp;
    if (!dpExists(dpName))
    {
      if (create)
      {
        dpCreate(dpName, "_FwSystemOverviewNotifications");
      }
      else 
      {
        dpName = "";
      }
    } 

  }
  return dpName;
}


void fwSysOverviewNotifications_removeAlarmRecipients(string application, string systemName, string alarmDpe)
{
  string notificationDp = fwSysOverviewNotifications_getAlarmNotificationsConfigDp(application, systemName, alarmDpe);
  alarmDpe = dpSubStr(alarmDpe, DPSUB_SYS_DP_EL);
  if (notificationDp != "")
  {
    dyn_string dpElements, dpeRecipients;
    dpGet(notificationDp + ".dpElements", dpElements,
          notificationDp + ".recipients", dpeRecipients);
    int pos = dynContains(dpElements, alarmDpe);
    if (pos > 0) //update recipients
    {
      dynRemove(dpElements, pos);
      dpeRecipients[pos] = "";
    }
   
    dpSet(notificationDp + ".dpElements", dpElements,
          notificationDp + ".recipients", dpeRecipients);
  }
}

void fwSysOverviewNotifications_updateAlarmRecipients(string application, string systemName, string alarmDpe, dyn_string newRecipients)
{
  string notificationDp = fwSysOverviewNotifications_getAlarmNotificationsConfigDp(application, systemName, alarmDpe, dynlen(newRecipients) > 0);
  alarmDpe = dpSubStr(alarmDpe, DPSUB_SYS_DP_EL);
  string recipientsStr = (string) newRecipients;
  strreplace(recipientsStr, " | ", ";");
  if (notificationDp != "")
  {
    dyn_string dpElements, dpeRecipients;
    dpGet(notificationDp + ".dpElements", dpElements,
          notificationDp + ".recipients", dpeRecipients);
    int pos = dynContains(dpElements, alarmDpe);
    if (pos > 0) //update recipients
    {
      dpeRecipients[pos] = recipientsStr;
    } 
    else    
    {
      dynAppend(dpElements, alarmDpe);
      dynAppend(dpeRecipients, recipientsStr);
    }

    dpSet(notificationDp + ".dpElements", dpElements,
          notificationDp + ".recipients", dpeRecipients);
   }
}

string fwSysOverviewNotifications_getAlarmRecipients(string application, string systemName, string alarmDpe)
{
  string recipients;
  string notificationDp = fwSysOverviewNotifications_getAlarmNotificationsConfigDp(application, systemName, alarmDpe);
  alarmDpe = dpSubStr(alarmDpe, DPSUB_SYS_DP_EL);
  if (notificationDp != "")
  {
    dyn_string dpElements, dpeRecipients;
    dpGet(notificationDp + ".dpElements", dpElements,
          notificationDp + ".recipients", dpeRecipients);
    int pos = dynContains(dpElements, alarmDpe);
    if (pos > 0) //update recipients
    {
      recipients = dpeRecipients[pos];
    }   
  }
  
  return recipients;
}
